searchData={"content_type":"text/markdown","items":[{"doc":"Query stats about an SQLite database.","ref":"EctoSQLite3Extras.html","title":"EctoSQLite3Extras","type":"module"},{"doc":"Compile-time options used when building SQLite.","ref":"EctoSQLite3Extras.html#compile_options/2","title":"EctoSQLite3Extras.compile_options/2","type":"function"},{"doc":"Size of indices.","ref":"EctoSQLite3Extras.html#index_size/2","title":"EctoSQLite3Extras.index_size/2","type":"function"},{"doc":"Run integrity checks on the database.","ref":"EctoSQLite3Extras.html#integrity_check/2","title":"EctoSQLite3Extras.integrity_check/2","type":"function"},{"doc":"Values of all bool or integer PRAGMAs.","ref":"EctoSQLite3Extras.html#pragma/2","title":"EctoSQLite3Extras.pragma/2","type":"function"},{"doc":"Get the map of all available queries.\n\nKey: The friendly query name atom (the same as the function name).\n\nValue: The name of the module defining the query behavior.","ref":"EctoSQLite3Extras.html#queries/1","title":"EctoSQLite3Extras.queries/1","type":"function"},{"doc":"Run the query specified by its slug atom and get (or print) the result.","ref":"EctoSQLite3Extras.html#query/3","title":"EctoSQLite3Extras.query/3","type":"function"},{"doc":"Sequence numbers of autoincrement columns.\n\nThe query will fail if there are no autoincrement columns in the DB yet.","ref":"EctoSQLite3Extras.html#sequence_number/2","title":"EctoSQLite3Extras.sequence_number/2","type":"function"},{"doc":"Size of tables (without indices).","ref":"EctoSQLite3Extras.html#table_size/2","title":"EctoSQLite3Extras.table_size/2","type":"function"},{"doc":"Total size of all tables and indices.","ref":"EctoSQLite3Extras.html#total_size/2","title":"EctoSQLite3Extras.total_size/2","type":"function"},{"doc":"Ecto repository module (or a pair of the module and the remote node).","ref":"EctoSQLite3Extras.html#t:repo/0","title":"EctoSQLite3Extras.repo/0","type":"type"},{"doc":"Compile-time options used when building SQLite","ref":"EctoSQLite3Extras.CompileOptions.html","title":"EctoSQLite3Extras.CompileOptions","type":"module"},{"doc":"","ref":"EctoSQLite3Extras.CompileOptions.html#info/0","title":"EctoSQLite3Extras.CompileOptions.info/0","type":"function"},{"doc":"","ref":"EctoSQLite3Extras.CompileOptions.html#query/1","title":"EctoSQLite3Extras.CompileOptions.query/1","type":"function"},{"doc":"Size of indices","ref":"EctoSQLite3Extras.IndexSize.html","title":"EctoSQLite3Extras.IndexSize","type":"module"},{"doc":"","ref":"EctoSQLite3Extras.IndexSize.html#info/0","title":"EctoSQLite3Extras.IndexSize.info/0","type":"function"},{"doc":"","ref":"EctoSQLite3Extras.IndexSize.html#query/1","title":"EctoSQLite3Extras.IndexSize.query/1","type":"function"},{"doc":"Run integrity checks on the database","ref":"EctoSQLite3Extras.IntegrityCheck.html","title":"EctoSQLite3Extras.IntegrityCheck","type":"module"},{"doc":"","ref":"EctoSQLite3Extras.IntegrityCheck.html#info/0","title":"EctoSQLite3Extras.IntegrityCheck.info/0","type":"function"},{"doc":"","ref":"EctoSQLite3Extras.IntegrityCheck.html#query/1","title":"EctoSQLite3Extras.IntegrityCheck.query/1","type":"function"},{"doc":"Values of all bool or integer PRAGMAs","ref":"EctoSQLite3Extras.Pragma.html","title":"EctoSQLite3Extras.Pragma","type":"module"},{"doc":"","ref":"EctoSQLite3Extras.Pragma.html#info/0","title":"EctoSQLite3Extras.Pragma.info/0","type":"function"},{"doc":"","ref":"EctoSQLite3Extras.Pragma.html#query/1","title":"EctoSQLite3Extras.Pragma.query/1","type":"function"},{"doc":"The entry point for each function.","ref":"EctoSQLite3Extras.Query.html","title":"EctoSQLite3Extras.Query","type":"behaviour"},{"doc":"","ref":"EctoSQLite3Extras.Query.html#c:info/0","title":"EctoSQLite3Extras.Query.info/0","type":"callback"},{"doc":"","ref":"EctoSQLite3Extras.Query.html#c:query/0","title":"EctoSQLite3Extras.Query.query/0","type":"callback"},{"doc":"Sequence numbers of autoincrement columns","ref":"EctoSQLite3Extras.SequenceNumber.html","title":"EctoSQLite3Extras.SequenceNumber","type":"module"},{"doc":"","ref":"EctoSQLite3Extras.SequenceNumber.html#info/0","title":"EctoSQLite3Extras.SequenceNumber.info/0","type":"function"},{"doc":"","ref":"EctoSQLite3Extras.SequenceNumber.html#query/1","title":"EctoSQLite3Extras.SequenceNumber.query/1","type":"function"},{"doc":"Size of tables (without indices)","ref":"EctoSQLite3Extras.TableSize.html","title":"EctoSQLite3Extras.TableSize","type":"module"},{"doc":"","ref":"EctoSQLite3Extras.TableSize.html#info/0","title":"EctoSQLite3Extras.TableSize.info/0","type":"function"},{"doc":"","ref":"EctoSQLite3Extras.TableSize.html#query/1","title":"EctoSQLite3Extras.TableSize.query/1","type":"function"},{"doc":"Total size of all tables and indices","ref":"EctoSQLite3Extras.TotalSize.html","title":"EctoSQLite3Extras.TotalSize","type":"module"},{"doc":"","ref":"EctoSQLite3Extras.TotalSize.html#info/0","title":"EctoSQLite3Extras.TotalSize.info/0","type":"function"},{"doc":"","ref":"EctoSQLite3Extras.TotalSize.html#query/1","title":"EctoSQLite3Extras.TotalSize.query/1","type":"function"},{"doc":"# Ecto SQLite3 Extras\n\nHelpful queries and [Phoenix Live Dashboard](https://github.com/phoenixframework/phoenix_live_dashboard) integration for [SQLite](https://sqlite.org/index.html). It's like [ecto_psql_extras](https://github.com/pawurb/ecto_psql_extras) but for SQLite instead of PostgreSQL.","ref":"readme.html","title":"Ecto SQLite3 Extras","type":"extras"},{"doc":"The package can be installed by adding `ecto_sqlite3_extras` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ecto_sqlite3_extras, \"~> 1.2.1\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Ecto SQLite3 Extras","type":"extras"},{"doc":"When you have `ecto_sqlite3_extras` in the list of dependencies for your [Phoenix](https://www.phoenixframework.org/) project that uses [ecto_sqlite3](https://github.com/elixir-sqlite/ecto_sqlite3), the [Phoenix Live Dashboard](https://github.com/phoenixframework/phoenix_live_dashboard) will automatically show the tables produced by `ecto_sqlite3_extras` in the \"Ecto Stats\" tab. Magic!\n\n![Example of live dashboard with ecto_sqlite3_extras](./assets/live-dashboard.png)","ref":"readme.html#integrating-with-phoenix-live-dashboard","title":"Integrating with Phoenix Live Dashboard - Ecto SQLite3 Extras","type":"extras"},{"doc":"If you don't have Phoenix Live Dashboard on the environment you want to inspect, you can use `ecto_sqlite3_extras` directly from the [iex](https://hexdocs.pm/iex/1.14/IEx.html) shell.\n\n```elixir\n# run the query and print a nice ASCII table into stdout\nEctoSQLite3Extras.table_size(MyProject.Repo)\n\n# get the raw output of the query\nEctoSQLite3Extras.table_size(MyProject.Repo, format: :raw)\n\n# run the query on a remote node\nEctoSQLite3Extras.table_size({MyProject.Repo, self()})\n```\n\n![Example of ecto_sqlite3_extras usage with iex](./assets/iex.png)","ref":"readme.html#using-from-elixir","title":"Using from Elixir - Ecto SQLite3 Extras","type":"extras"},{"doc":"1. `total_size`. The total size of all tables and indices. It's a summary table, it has only 2 columns: `name` and `value`. Rows:\n    1. `cells`: The number of cells in the DB. Each value stored in the DB is represented as at least one cell. So, the number of cells correlates with the number of records in the DB.\n    1. `payload_size`: How much space the actual useful payload takes in the DB.\n    1. `unused_size`: How much space in the DB is reserved, not used yet, and can be used later to store more data. This is a surplus that occurs because SQLite allocates space for data in chunks (\"pages\").\n    1. `vacuum_size`: How much space is unused and cannot be used for future data. You can run [VACUUM](https://www.sqlite.org/lang_vacuum.html) command to reduce it.\n    1. `page_size`: The total space occupied by all pages. Each page is a single chunk of space allocated by SQLite. This number is the sum of `payload_size`, `unused_size`, and `vacuum_size`.\n    1. `pages`: The total number of pages.\n    1. `pages: leaf`: The pages that store the actual data. Read [SQLite Internals: Pages & B-trees](https://fly.io/blog/sqlite-internals-btree/) to learn more.\n    1. `pages: internal`: The pages that store ranges for leaf pages for a faster lookup. Sometimes also called \"interior pages\".\n    1. `pages: overflow`: The pages that store chunks of big data that don't fit in a single leaf page.\n    1. `pages: table`: The pages used for storing data for tables.\n    1. `pages: index`: The pages used for storing indices.\n1. `table_size`. Information about the space used (and unused) by all tables. Based on the [dbstat](https://www.sqlite.org/dbstat.html) virtual table.\n    1. `name`: The table name.\n    1. `payload_size`.\n    1. `unused_size`.\n    1. `vacuum_size`.\n    1. `page_size`.\n    1. `cells`.\n    1. `pages`.\n    1. `max_payload_size`: The size of the biggest payload in the table.\n1. `index_size`. Size of all indices.\n    1. `name`: The index name.\n    1. `table_name`: The table where the index is defined.\n    1. `column_name`: The name of the column being indexed. This column is NULL if the column is the rowid or an expression.\n    1. `payload_size`.\n    1. `unused_size`.\n    1. `page_size`.\n    1. `cells`.\n    1. `pages`.\n    1. `max_payload_size`.\n1. `sequence_number`. Sequence numbers of autoincrement columns. Generated based on the [sqlite_sequence](https://renenyffenegger.ch/notes/development/databases/SQLite/internals/schema-objects/sqlite_sequence) table. The query will fail if there are no autoincrement columns in the DB yet.\n    1. `table_name`.\n    1. `sequence_number`.\n1. `pragma`. List values of PRAGMAs (settings). Only includes the ones that have an integer or a boolean value. For brevity, the ones with the `0` (`false`) value are excluded from the output (based on the observation that this is the default value for most of the PRAGMAs). Check out the SQLite documentation to learn more about what each PRAGMA means: [PRAGMA Statements](https://www.sqlite.org/pragma.html).\n    1. `name`: the name of the PRAGMA as listed in the SQLite documentation.\n    1. `value`: the value of the PRAGMA. The `true` value is converted into `1` (and `false` is simply excluded).\n1. `compile_options`. List the [compile-time options](https://www.sqlite.org/compile.html) used when building SQLite, one option per row. The \"SQLITE_\" prefix is omitted from the returned option names. See [exqlite docs](https://github.com/elixir-sqlite/exqlite#defining-extra-compile-flags) on how to change these options.\n1. `integrity_check`. Run integrity checks on the database. Executes [PRAGMA integrity_check](https://www.sqlite.org/pragma.html#pragma_integrity_check) and returns the resulting messages.","ref":"readme.html#available-queries","title":"Available queries - Ecto SQLite3 Extras","type":"extras"},{"doc":"These are the projects that made `ecto_sqlite3_extras` possible:\n\n1. [phoenix_live_dashboard](https://github.com/phoenixframework/phoenix_live_dashboard) is the reason why I made the project. I want my SQLite-powered Phoenix service to have the same nice-looking live dashboard as for PostgreSQL.\n1. [exqlite](https://github.com/elixir-sqlite/exqlite) provides SQLite support for Elixir. They [enabled just for me](https://github.com/elixir-sqlite/exqlite/issues/231) the `SQLITE_ENABLE_DBSTAT_VTAB` option required for `ecto_sqlite3_extras` to work, literally making this project possible.\n1. [ecto_psql_extras](https://github.com/pawurb/ecto_psql_extras) is a similar project for PostgreSQL. I shamelessly copied the project structure and tests, so that I can be sure that `ecto_sqlite3_extras` can be a drop-in replacement for `ecto_psql_extras`.","ref":"readme.html#acknowledgments","title":"Acknowledgments - Ecto SQLite3 Extras","type":"extras"}]}